<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------
| Validar formulari
| -------------------------------------------------------------------
| Es disposa d'un array amb les regles
| de confirmació del formulari
|
*/
$config = array(
                'convocatoria' 	=> array(
									array(
                                            'field' => 'nom_convocatoria',
                                            'label' => 'Nom',
                                            'rules' => 'required|trim|min_length[3]|max_length[30]'
                                         ),
                                    array(
                                            'field' => 'id_convocatoria',
                                            'label' => 'Identificador',
                                            'rules' => 'required|trim|min_length[5]|max_length[20]'
                                         ),
                                    array(
                                            'field' => 'data_inici',
                                            'label' => 'Data Inici',
                                            'rules' => 'required|trim|min_length[5]|max_length[20]'
                                         ),
                                    array(
                                            'field' => 'data_fi',
                                            'label' => 'Data Fi',
                                            'rules' => 'required|trim|min_length[10]|max_length[10]'
                                         )
                                    ),
                'excel' 	=> array(
                                    array(
                                            'field' => 'id_convocatoria',
                                            'label' => 'Arxiu Excel',
                                            'rules' => 'required'
                                         )
                                    ),
				'usuari' 	=> array(
                                    array(
                                            'field' => 'nom_usuari',
                                            'label' => 'Nom',
                                            'rules' => 'required|trim|min_length[3]|max_length[30]'
                                         ),
                                    array(
                                            'field' => 'cognoms_usuari',
                                            'label' => 'Cognoms',
                                            'rules' => 'required|trim|min_length[3]|max_length[40]'
                                         ),                  
                                    array(
                                            'field' => 'password_usuari',
                                            'label' => 'Contrasenya',
                                            'rules' => 'matches[password_conf]|trim|min_length[5]|max_length[50]'
                                         ),
									array(
                                            'field' => 'password_conf',
                                            'label' => 'Contrasenya confirmada',
                                            'rules' => 'trim|min_length[5]|max_length[50]'
                                         ),
									array(
                                            'field' => 'id_usuari',
                                            'label' => 'Identificador',
                                            'rules' => 'required|trim|min_length[5]|max_length[20]'
                                         ),
									array(
                                            'field' => 'mail_usuari',
                                            'label' => 'Correu',
                                            'rules' => 'required|trim|min_length[5]|max_length[30]|valid_email'
                                         ),
									array(
                                            'field' => 'rol_usuari',
                                            'label' => 'Rol',
                                            'rules' => 'required|trim|min_length[1]|max_length[2]|numeric|greater_than[0]|less_than[3]'
                                         )		
										 
                                    ),
				'personals' => array(                       
                                    array(
                                            'field' => 'password_usuari',
                                            'label' => 'Contrasenya',
                                            'rules' => 'matches[password_conf]|trim|min_length[5]|max_length[50]'
                                         ),
									array(
                                            'field' => 'password_conf',
                                            'label' => 'Contrasenya confirmada',
                                            'rules' => 'trim|min_length[5]|max_length[50]'
                                         ),
									array(
                                            'field' => 'id_smtp',
                                            'label' => 'Identificador SMTP/IMAP',
                                            'rules' => 'trim|min_length[5]|max_length[30]'
                                         ),
									array(
                                            'field' => 'password_smtp',
                                            'label' => 'Password SMTP/IMAP',
                                            'rules' => 'matches[password_smtp_conf]|trim|min_length[5]|max_length[50]'
                                         ),	
									array(
                                            'field' => 'password_smtp_conf',
                                            'label' => 'Password SMTP/IMAP Confirmada',
                                            'rules' => 'trim|min_length[5]|max_length[50]'
                                         )	
										 
                                    ),
				'alumne' => array(                                  
									array(
                                            'field' => 'correu',
                                            'label' => 'Correu',
                                            'rules' => 'required|trim|min_length[5]|max_length[30]|valid_email'
                                         )	
										 
                                    )	,
				'password' => array(                                  
									array(
                                            'field' => 'id_usuari',
                                            'label' => 'Identificador',
                                            'rules' => 'required|min_length[3]|max_length[12]'
                                         ),
									array(
                                            'field' => 'mail_usuari',
                                            'label' => 'Mail Usuari',
                                            'rules' => 'required|min_length[5]|max_length[40]|valid_email'
                                         )
										 
                                    )	,
					'login' => array(                                  
									array(
                                            'field' => 'usuari',
                                            'label' => 'Identificador',
                                            'rules' => 'required|trim|min_length[3]|max_length[17]'
                                         ),
									array(
                                            'field' => 'password',
                                            'label' => 'Contrasenya',
                                            'rules' => 'required|trim|min_length[5]|max_length[20]'
                                         )	
										 
                                    )	,
					'seguiment' => array(                                  
									array(
                                            'field' => 'eleccio',
                                            'label' => 'Mail a enviar',
                                            'rules' => 'required|trim|min_length[1]|max_length[2]|greater_than[1]'
                                         ),
									array(
                                            'field' => 'seleccio',
                                            'label' => 'Llista alumnes',
                                            'rules' => 'required'
                                         )	
									
										 
                                    )	,	
					'missatges' => array(                                  
									array(
                                            'field' => 'cos',
                                            'label' => 'text',
                                            'rules' => 'required'
                                         ),
									array(
                                            'field' => 'destinataris',
                                            'label' => 'Mails',
                                            'rules' => 'required'
                                         ),	
									array(
                                            'field' => 'assumpte',
                                            'label' => 'Assumpte',
                                            'rules' => 'required'
                                         ),
									array(
                                            'field' => 'alumnes',
                                            'label' => 'Alumnes',
                                            'rules' => 'required'
                                         )	
										 
                                    )
									
               );