<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * Classe que representa la plana d'inici interna de l'aplicació.
 * @author David Español Diaz
 * @versió 1.0; PHP 5.0".
 */
class Inici extends CI_Controller{
	
	//Definició del constructor.
	function __construct(){
	
		parent::__construct();
		//Carrega llibreries i helpers.
		$this->load->helper(array('url', 'form'));
		$this->load->library(array('session','imap','encrypt'));
		//Si no esta connectat no es pot visualitzar la plana.
		if(!$this->session->userdata('autenticacio')){
			$this->session->set_flashdata('error', 'No has fet login.');
			redirect('login', 'refresh');
		}
		//Carrega el model Convocatòries/Inici.
		$this->load->model('Inici_model');
		$this->load->model('Convocatories_model');	

		
	}
	
	/**
     * Mètode per carregar l'inici de la pàgina.
	 * Recull les dades a mostrar a la vista.
     */
	function index() {
			
		//Segons el rol d'usuari podrà veure uns continguts o altres.
		$rol=$this->session->userdata('rol_usuari');
		if($rol==1){
			//Redirecciona si es l'administrador.
			redirect('inici/admin', 'refresh');	
		}
		//Recull les dades de sessió.
		$id_convocatoria = $this->session->userdata('convocatoria_actual');
		$id_tutor = $this->session->userdata('id_usuari');
			
		//Crea objecte Convocatoria	
		$id_conv=$this->Convocatories_model->veureConvocatoriaActual($id_tutor);
		$obj_conv=new Convocatories_model($id_conv,$id_tutor);
			
		//Verificar inici de convocatòria.		
		$dada['actconv']=$this->Inici_model->verificarIniciConvocatoria($obj_conv);
		if ($dada != -1){
			//Darrer estat.
			$dada['actconv'][0]->status=$this->Convocatories_model->darrerEstatConvocatoria($id_conv);
			//Informe benvinguda.
			$dada['actconv'][0]->benvinguda_falta=$this->Inici_model->obtenirInformeBenvinguda($obj_conv);
			//Cridar als informes segons estat.
			$dada['actconv'][0]->benvinguda_rebuda=$this->Inici_model->obtenirInforme($obj_conv,2);
			$dada['actconv'][0]->benvinguda_retornada=$this->Inici_model->obtenirInforme($obj_conv,3);
			$dada['actconv'][0]->alumnes_baixa=$this->Inici_model->obtenirInforme($obj_conv,4);
			$dada['actconv'][0]->alumnes_superacio=$this->Inici_model->obtenirInforme($obj_conv,9);
			//Informe alumnes totals.
			$alumnes_totals=$this->Inici_model->obtenirInformeAlumnesTotals($obj_conv);
			$dada['actconv'][0]->alumnes_totals=$alumnes_totals;
			//Informe alumnes no contactats.
			$alumnes_nocontact=$this->Inici_model->obtenirInformeAlumnesNoContactats($obj_conv);
			$dada['actconv'][0]->alumnes_no_contactats=$alumnes_totals-$alumnes_nocontact;
		}
		else{ $dada['actconv']=''; }
				
		//Agafar valors de imap de l'arxiu config.
		$imap_server = $this->config->item('imap_server');
				
		//Crear objecte usuari.
		$this->load->model('Usuaris_model');
		$obj_smtp=new Usuaris_model($id_tutor);
		//Obtenir dades de connexió al gestor de correu personal.
		if($obj_smtp->veureSmtpUsuari()!=-1){
			$datasmtp['smtp']=$obj_smtp->veureSmtpUsuari();
			$id_smtp=$datasmtp['smtp'][0]->id_smtp;
			$password_smtp=$this->encrypt->decode($datasmtp['smtp'][0]->password_smtp);
				
			//Fer la connexió al correu electrònic del tutor.
			if($this->imap->connect($id_smtp,$password_smtp,$imap_server,'INBOX')==TRUE){
				$resultat=$this->imap->msg_unseen();
				$nous = $resultat->unseen;
				$this->imap->close();
				$dada['actconv'][0]->nous=$nous;
			}
		} else{
			//Si l'usuari no ha posat dades de connexió al mail ho indica.
			$dada['actconv'][0]->nous='No has posat dades de connexió al teu gestor de correu i per tant no pots accedir als moduls Seguiment/Missatges';
		}
			
		//Carrega la vista.
		$this->load->view('inici_view',$dada);	
	}
	
	/**
     * Mètode per carregar l'inici de la pàgina d'aministrador.
	 * Recull les dades a mostrar a la vista.
     */
	function admin() {
		$rol=$this->session->userdata('rol_usuari');
		if($rol==1){
			//Carrega la vista.
			$this->load->view('inici_admin_view');	
		}
	}
}
?>