<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * Code Igniter
 *
 * An open source application development framework for PHP 4.3.2 or newer
 *
 * @package		CodeIgniter
 * @author		Rick Ellis
 * @copyright	Copyright (c) 2006, pMachine, Inc.
 * @license		http://www.codeignitor.com/user_guide/license.html
 * @link		http://www.codeigniter.com
 * @since		Version 1.0
 * @filesource
 */

// ------------------------------------------------------------------------


// ------------------------------------------------------------------------

class Imap {

	var $CI;
	var $remote_name;
	var $port;
	var $mailbox;
	var $user;
	var $pass;
	var $mbox;
	var $stream;
	var $default_mailbox = 'INBOX';
	
	function Imap()
	{	
		$this->CI =& get_instance();
		log_message('debug', "Imap Class Initialized");
	}


	function connect($user = NULL, $pass = NULL, $server = NULL, $carpeta)
	{
		$this->user		= $this->CI->config->item('imap_user');
		$this->pass		= $this->CI->config->item('imap_pass');
		$this->flags	= $this->CI->config->item('imap_flags');
		$this->port		= $this->CI->config->item('imap_port');
		$this->mailbox	= $this->CI->config->item('imap_mailbox');
		$this->server	= $this->CI->config->item('imap_server');
		
		if($user)
		{
			$this->user = $user;
		}
		
		if($pass)
		{
			$this->pass = $pass;
		}
		
		if($server)
		{
		
		}	$this->server = $server;

		// Let's start building the stream's string
		$this->mbox		= '{' . $this->server;

		if($this->port)
		{
			$this->mbox .=  ':' . $this->port;
		}
		
		/*if($this->flags)
		{
			$this->mbox .= $this->flags;
		}*/

		//$this->mbox .= '/user="' . $this->user . '"';
		$this->mbox .= '/imap/ssl';
		
		
		
		
		if($carpeta==NULL || $carpeta=='INBOX'){

			$this->mbox .= '}INBOX';
		}
		
		
		else {$this->mbox .='}[Gmail]/'.$carpeta;}
		
		
		

		if($this->mailbox)
		{
			$this->mbox .= $this->default_mailbox;
		}

		$this->stream = @imap_open($this->mbox,$this->user,$this->pass);
		if (FALSE === $this->stream)
		{
			return imap_last_error(); //se pone false a bajo para ver que pasa si no puede conectar.
			//return FALSE;
		}

		return TRUE;
	}
	
	function msg_unseen()
	{
		if($this->stream)
		{
			$status = imap_status($this->stream,'{imap.gmail.com}',SA_UNSEEN);
			return $status;
		}
		
	}
	
	function msg_count()
	{
		if($this->stream)
		{
			return imap_num_msg($this->stream);
		}
		
		// Not connected!
		return imap_last_error();
	}

	/**
	 * Versi David Espaol Diaz
	 * Veure llista missatges.
	 * @access	public
	 * @param	String
	 * @return	Array
	 */
	function msg_list($msg_list)
	{
		if($this->stream)
		{
			$return = array();
			if($msg_list != '')
			{
				//Noms 5.
				$count_max=5;
				$count=$msg_list;
				
				$message=1;
				imap_sort($this->stream, SORTDATE, 1); 
				$CI =& get_instance(); 

				do{
					$header = imap_headerinfo($this->stream, $count);
					//Dades del missatge.
					$nou_flag=$header->Unseen;
					$repply=$header->Answered;
					$from1 = $header->from;
					$real_id=imap_uid ($this->stream,$count);
						
					$this->CI->load->model('Missatges_model');				
					$resposta=$this->CI->Missatges_model->comprovarResposta($real_id);
							
					foreach ($from1 as $id => $object) {
							
						// Extreu nom remitent
						// En cas que no existeixi nom dona valor buit.
						$from0= $object->personal;
						
						$fromname = $object->personal;
						$senderaddress = $object->mailbox . "@" . $object->host;
					}
						
						$utf=iconv_mime_decode($header->subject);
						$fromfinal=iconv_mime_decode($from0);
						$return[$message]= (object)array('from' => utf8_encode($fromfinal),
							 'subject' => utf8_encode($utf),
							 'date'    => $header->date,
							 'id_missatge' =>$count,
							 'new_flag' =>$nou_flag,
							 'repply' =>$repply,
							 'from_mail' =>$senderaddress,
							 'resposta' =>$resposta,
							 'real_id' =>$real_id,
							 );
						
						$count--;
						$message++;			

						
				}while($message<=$count_max && $count>0);	
			}		
			return $return;
		}	
		return imap_last_error();
	}
	
	/**
	 * Versi David Espaol Diaz
	 * Veure carpetes.
	 * @access	public
	 * @return	Array
	 */
	function carpeta_list()
	{
		if($this->stream)
		{	
			$carpetes = imap_list($this->stream, '{imap.gmail.com}', '*');
			return $carpetes;
		}
		return imap_last_error();
	}

	
	function decode_ISO88591($string) {
		$string=str_replace("=?iso-8859-1?q?","",$string);
		$string=str_replace("=?iso-8859-1?Q?","",$string);
		$string=str_replace("?=","",$string);

		$charHex=array("0","1","2","3","4","5","6","7",
		"8","9","A","B","C","D","E","F");

		for($z=0;$z<sizeof($charHex);$z++)
		{
			for($i=0;$i<sizeof($charHex);$i++){
				$string=str_replace(("=".($charHex[$z].$charHex[$i])),
				chr(hexdec($charHex[$z].$charHex[$i])),
				$string);
			}
		}
		return($string);
	}
	
	/**
	 * Versi David Espaol Diaz.
	 * Veure missatge.
	 * @access	public
	 * @param	String
	 * @return	Array
	 */
	function veureMissatge($id_missatge)
	{
		if($this->stream)
		{	
			if($id_missatge != NULL){
				// Comprova quin tipus de missatges s.
				$seccion = imap_fetchstructure($this->stream,$id_missatge); 
				if($seccion->subtype == "ALTERNATIVE"){
					$section=2;
				}
				if($seccion->subtype == "PLAIN"){
					$section=1;
				}
				if($seccion->subtype == "MIXED"){	
					$section=1.2;
					//Extreu seccions.
					if(isset($seccion->parts[0]->parts[1]->subtype))
					{
						if($seccion->parts[0]->parts[1]->subtype=="HTML"){
							$section=1.2;
						}
					}
					else{
						$section=1.1;
					}
				}
				$string = imap_fetchbody($this->stream, $id_missatge, $section);
				$string=quoted_printable_decode($string);

				$string=str_replace("=?iso-8859-1?q?","",$string);
				$string=str_replace("=?iso-8859-1?Q?","",$string);
				$string=str_replace("?=","",$string);
				
				$charHex=array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");
				
				//Canvia carcters UTF8
				for($z=0;$z<sizeof($charHex);$z++)
				{
					for($i=0;$i<sizeof($charHex);$i++){
						$string=str_replace(("=".($charHex[$z].$charHex[$i])),
						chr(hexdec($charHex[$z].$charHex[$i])),
						$string);
					}
				}
			}
			return $string;
		}	
		return imap_last_error();
	}
	
	
	function search($params)
	{
		if($this->stream)
		{
			if(is_array($params))
			{
				$search_string = '';
				foreach($params as $field => $value)
				{
					if(is_numeric($field))
					{
						// Make sure the value is uppercase
						$search_string .= strtoupper($value) . ' ';	
						
					}
					else
					{
						$search_string .= strtoupper($field) . ' "' . $value . '" ';
					}
				}
				
				// Perform the search
				#echo "'$search_string'";
				return imap_search($this->stream, $search_string);
			}
			else
			{
				return imap_last_error();
			}
		}

		return imap_last_error();
	}
	
	
	
	function delete($emails, $delete=FALSE)
	{
		if($this->stream)
		{
			if(is_array($emails))
			{
				// Let's delete multiple emails
				if(count($emails) > 0)
				{
					$delete_string = '';
					$email_error = array();
					foreach($emails as $email)
					{
						if($delete)
						{
							if(! @imap_delete($this->stream, $email))
							{
								$email_error[] = $email;
							}
						}
					}
					if(! $delete)
					{
						// Need to take the last comma out!
						$delete_string = implode(',', $emails);
						echo $delete_string;
						imap_mail_move($this->stream, $delete_string, "Inbox/Trash");
						imap_expunge($this->stream);
					}
					else
					{
						// NONE of the emails were deleted
						if(count($email_error) === count($emails))
						{
							return imap_last_error();
						}
						else
						{
							$return['status'] = FALSE;
							$return['not_deleted'] = $email_error;
							return $return;
						}
					}
				}
				else
				{
					return imap_last_error();
				}
			}
			else
			{
				if(! $delete)
				{
					return @imap_mail_move($this->stream, $emails, "INBOX/trash");
				}
				else
				{
					// We only want to delete one email
					if(imap_delete($this->stream, $emails))
					{
						return TRUE;	// Success
					}
					else
					{
						return imap_last_error();	// Failed
					}
				}
			}
		}

		// Not connected
		return imap_last_error();
	}

	function switch_mailbox($mailbox = '')
	{	
		if($this->stream)
		{
			$this->mbox = '{' . $this->CI->config->item('imap_server');

			if($this->port)
			{
				$this->mbox .=  ':' . $this->port;
			}
			
			if($this->flags)
			{
				$this->mbox .= $this->flags;
			}
			
			$this->mbox .= '/user="' . $this->user . '"';
			$this->mbox .= '}';
			$this->mbox .= $this->default_mailbox;
			
			if($mailbox)
			{
				$this->mbox .= '.' . $mailbox;
			}

			return @imap_reopen($this->stream, $this->mbox);
		}
		
		// Not connected
		return imap_last_error();
	}

	function current_mailbox()
	{
		if($this->stream)
		{
			$info = imap_mailboxmsginfo($this->stream);
			if($info)
			{
				return $info->Mailbox;
			}
			else
			{
				// There was an error
				return imap_last_error();
			}
		}
		
		// Not connected
		return imap_last_error();
	}

	function mailbox_info($type='obj')
	{
		if($this->stream)
		{
			$info = imap_mailboxmsginfo($this->stream);
			if($info)
			{
				if($type == 'array')
				{
					foreach($info as $field => $value)
					{
						$info_array[$field] = $value;
					}
					return $info_array;
				}
				else
				{
					return $info;
				}
			}
			else
			{
				// There was an error
				return imap_last_error();
			}
		}
		
		// Not connected
		return imap_last_error();
	}
	
	
	
	function close()
	{
		if($this->stream)
		{
			return @imap_close($this->stream);
		}
		
		return imap_last_error();
	}
}

?>