<?php
 /**
 * Classe que representa el seguiment d'una convocatoria
 * @author David Español Diaz
 * @version 1.0; PHP 5.0".
 */
class seguiment_model extends CI_Model {

	private $taula_alumnes="alumnes";
	private $taula_estat_alumnes="estat_alumnes";
	private $id_alumne;
	private $nom;
	private $cognoms;
	private $mail;
	private $id_convocatoria;
	
	/**
     * Mètode constructor del seguiment.
     * {pre: Cap}
     * {post: retorna una instància de la classe Seguimenti carrega la base de dades.
     */
	public function __construct() {
		// Crida el Model constructor
		parent::__construct();
		$this->load->database();
		
		$args = func_get_args();
		$nargs = func_num_args();
		switch($nargs) {
			case 0:
				break;
			case 1:
				$this->id_convocatoria=$args[0];
				break;
		}
    }
	
	/**
     * Métode per obtenir la llista d'alumnes d'una convocatòria i dades secundaries.
     * @return Array - Llistat d'alumnes i dades o -1 si no hi ha llistat.
     */
	function llistatAlumnesSeguiment(){
		$this->load->model('Alumnes_model');
		$this->db->where('id_convocatoria', $this->id_convocatoria);
		$query=$this->db->order_by("cognoms")->get($this->taula_alumnes);
		
		//Si s'han trobat valors a la BBDD retorna un array. En cas contrari -1.
        if ($query->num_rows>0){
			$new_array = array();
			$i = 0; 
            $result = $query->result();
            foreach ($result as $row){
				// Introdueix totes les dades en un array.
                $new_array[$i]= (object)array('id_alumne' => $row->id_alumne,
                     'nom' => $row->nom,
                     'cognoms'    => $row->cognoms,
					 'mail'    => $row->mail,
					 'id_convocatoria'    => $row->id_convocatoria,
					 'darrer_estat'   => $this->Alumnes_model->obtenirDarrerEstatAlumne($row->id_alumne,$this->id_convocatoria),
					 'benvinguda'   => $this->Alumnes_model->obtenirBenvingudaAlumne($row->id_alumne,$this->id_convocatoria),
					 'feedback'   => $this->Alumnes_model->obtenirFeedback($row->id_alumne,$this->id_convocatoria)
				);
                ++$i; 
			}
			return $new_array;
        } else{
			$value=-1;
			$dada= array('id_alumne' => $value);
			return $dada;
		}
	}
	
	/**
     * Mètode per cercar una plantilla a dintre d'una llista.
     * {pre: Hi ha una plantilla a extreure}.
     * {post: Es crea una plantilla amb les dades recullides}.
     * Retorna missatges d'error si el formulari no es correcte.
     */
	function getPlantillaAEnviar($id_missatge,$id_convocatoria,$nom_curs,$data_inici,$data_fi,$nom_tutor){
		//Carrega les plantilles.
		include('application/includes/plantilles.php');
		//En funció del parametre recullit retorna una plantilla.
		//2: Benvinguda, 5: No iniciat, 6: Retras, 7: Correcte, 8: Termini, 9: Finalització. 
		switch ($id_missatge) {
			case 2:
				$mail=$benvinguda;
				break;
			case 5:
				$mail=$no_iniciat;
				break;
			case 6:
				$mail=$retras;
				break;
			case 7:
				$mail=$be;
				break;
			case 8:
				$mail=$termini;
				break;
			case 9:
				$mail=$superacio;
				break;
		}
		return $mail;
	}	
}
?>